VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PhoneNumber"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Event PhoneChanged _
                    ( _
                    p_strPropertyName As String _
                    )
              
Private Const MODULE As String = "PhoneNumber"
              
Private m_strDescription    As String
Private m_strCountryCode    As String
Private m_strCityCode       As String
Private m_strLocalNumber    As String
Private m_blnRaiseEvents    As Boolean

Friend Property Let RaiseEvents _
                        ( _
                        ByVal RHS As Boolean _
                        )

    Const PROC_SIG As String = MODULE & "." & "RaiseEvents[Let]"
    
    On Error GoTo ErrorHandler

    m_blnRaiseEvents = RHS

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Friend Property Get RaiseEvents() As Boolean

    RaiseEvents = m_blnRaiseEvents

End Property

Friend Function Serialize _
                        ( _
                        Optional p_blnAddDescription As Boolean = True _
                        ) As String
    
    Const PROC_SIG As String = MODULE & "." & "Serialize[Function]"
    
    Dim v_strDescription As String
    Dim v_strCountry As String
    Dim v_strCity As String
    Dim v_strLocal As String
    Dim v_strSerial As String
    
    On Error GoTo ErrorHandler
    
    With Me
         
        If Len(.Description) > 0 Then
            
            v_strDescription = .Description & ":"
        
        End If
        
        If Len(.CountryCode) > 0 Then
        
            If Len(.CityCode) > 0 Or Len(.LocalNumber) > 0 Then
            
                v_strCountry = "+" & .CountryCode
            
            End If
                
        End If
        
        If Len(.CityCode) > 0 Then
        
            v_strCity = "(" & .CityCode & ")"
        
        End If
        
        v_strSerial = Trim$(IIf(p_blnAddDescription, v_strDescription & " ", vbNullString) & _
                        Trim$(v_strCountry & " " & v_strCity & " " & .LocalNumber))
    
    End With
        
    Serialize = v_strSerial
    
ExitHere:
    Exit Function
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Function

Friend Function GetCountryDescription _
                        ( _
                        p_strCountryList As String _
                        ) As String

    Const PROC_SIG As String = MODULE & "." & "GetCountryDescription[Function]"
    
    Dim v_lngInstr As Long
    Dim v_strCountryList As String
    
    On Error GoTo ErrorHandler
    
    If Len(Me.CountryCode) > 0 Then
    
        If Len(p_strCountryList) > 0 Then
        
            v_lngInstr = InStr(1, p_strCountryList, "=" & Me.CountryCode & "@", vbTextCompare)
            
            If v_lngInstr > 0 Then
            
                v_strCountryList = Left$(p_strCountryList, v_lngInstr - 1)
                
                v_lngInstr = InStrRev(v_strCountryList, "@")
                
                If v_lngInstr > 0 Then
                
                    GetCountryDescription = Mid$(v_strCountryList, v_lngInstr + 1)
                
                End If
            
            End If
            
        End If
        
    End If
    
ExitHere:
    Exit Function
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Function

Public Property Let Description _
                        ( _
                        ByVal RHS As String _
                        )

    Const PROC_SIG As String = MODULE & "." & "Description[Let]"
    
    On Error GoTo ErrorHandler
    
    m_strDescription = Trim$(RHS)
    
    If RaiseEvents Then
        RaiseEvent PhoneChanged("Description")
    End If
    
ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get Description() As String
Attribute Description.VB_Description = "Returns/sets the description of the phone number"

    Description = m_strDescription

End Property

Public Property Let CityCode _
                        ( _
                        ByVal RHS As String _
                        )
    Const PROC_SIG As String = MODULE & "." & "CityCode[Let]"

    On Error GoTo ErrorHandler
    
    m_strCityCode = StripBrackets(Trim$(RHS))
    
    If RaiseEvents Then
        RaiseEvent PhoneChanged("CityCode")
    End If

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get CityCode() As String
Attribute CityCode.VB_Description = "Returns/sets the City code of the phone number"

    CityCode = m_strCityCode

End Property

Public Property Let CountryCode _
                        ( _
                        ByVal RHS As String _
                        )

    Const PROC_SIG As String = MODULE & "." & "CountryCode[Let]"

    On Error GoTo ErrorHandler
    
    m_strCountryCode = StripPlus(Trim$(RHS))
    
    If RaiseEvents Then
        RaiseEvent PhoneChanged("CountryCode")
    End If

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get CountryCode() As String
Attribute CountryCode.VB_Description = "Returns/sets the Country code of the phone number"

    CountryCode = m_strCountryCode

End Property

Public Property Let LocalNumber _
                        ( _
                        ByVal RHS As String _
                        )

    Const PROC_SIG As String = MODULE & "." & "LocalNumber[Let]"

    On Error GoTo ErrorHandler

    m_strLocalNumber = Trim$(RHS)
    
    If RaiseEvents Then
        RaiseEvent PhoneChanged("LocalNumber")
    End If
    
ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get LocalNumber() As String
Attribute LocalNumber.VB_Description = "Returns/sets the Local number of the phone number"
Attribute LocalNumber.VB_UserMemId = 0

    LocalNumber = m_strLocalNumber

End Property

